// Source file: c:/DopeWars/DopeWars/DataHolders/GameSettingsD.java

package DopeWars.DopeWars.DataHolders;

import java.io.*;
import java.util.*;

public class GameSettingsD implements Serializable {
    private int m_turnLength = 120;
    private ArrayList m_locationList;
    private ArrayList m_drugSettingList;
    private int m_turns = 3;
    private int m_startPockets = 100;
    private int m_startBankMoney = 0;
    private int m_startMoney = 2000;
    private int m_startLoanMoney = 5500;
    private float m_loanInterest = 1.125f;

    public GameSettingsD() {
			m_locationList = new ArrayList();
			m_drugSettingList = new ArrayList();

			// Add in default locations
			m_locationList.add(new LocationD("Bronx"));
			m_locationList.add(new LocationD("Ghetto"));
			m_locationList.add(new LocationD("Central Park"));
			m_locationList.add(new LocationD("Manhattan"));
			m_locationList.add(new LocationD("Coney Island"));
			m_locationList.add(new LocationD("Brooklyn"));

			// Add in default drugs
			m_drugSettingList.add(new DrugSettingsD("Acid", 4000, 1000, 1));
			m_drugSettingList.add(new DrugSettingsD("Cocaine", 30000, 15000, 1));
			m_drugSettingList.add(new DrugSettingsD("Ludes", 5, 50, 1));
			m_drugSettingList.add(new DrugSettingsD("PCP", 5000, 10000, 1));
			m_drugSettingList.add(new DrugSettingsD("Heroin", 10000, 15000, 1));
			m_drugSettingList.add(new DrugSettingsD("Weed", 400, 1000, 1));
			m_drugSettingList.add(new DrugSettingsD("Shrooms", 800, 2000, 1));
			m_drugSettingList.add(new DrugSettingsD("Speed", 50, 200, 1));
    }

    /**
       @roseuid 3926DBC80375
     */
    public int getTurnLength() {
			return m_turnLength;
    }

    /**
       @roseuid 3926DBD602E9
     */
    public void setTurnLenth(int turnLength) {
			m_turnLength = turnLength;
    }

    public int getTurns() {
			return m_turns;

		}

    /**
       @roseuid 3926DBE1021C
     */
    public ArrayList getLocationList() {
			return m_locationList;
    }

		public void setLocationList(ArrayList locationList) {
			m_locationList = locationList;
		}

    public ArrayList getDrugSettingList() {
			return m_drugSettingList;
    }

		public void setDrugSettingList(ArrayList drugList) {
			m_drugSettingList = drugList;
		}


    /**
       @roseuid 3926DC0302C6
     */
    public void addLocation(LocationD location) {
    }

		public int getStartPockets() {
			return m_startPockets;
		}

		public void setStartPockets(int startPockets) {
			m_startPockets = startPockets;
		}

    public int getStartBankMoney() {
			return m_startBankMoney;
		}

		public void setStartBankMoney(int startBankMoney) {
			m_startBankMoney = startBankMoney;
		}

    /**
       @roseuid 3926DC1501D1
     */
    public int getStartMoney() {
			return m_startMoney;
    }

    /**
       @roseuid 3926DC1B0306
     */
    public void setStartMoney(int startMoney) {
			m_startMoney = startMoney;
    }

    /**
       @roseuid 3926DC2400EC
     */
    public int getStartLoanMoney() {
			return m_startLoanMoney;
    }

    /**
       @roseuid 3926DC2F037D
     */
    public void setStartLoanMoney(int startLoanMoney) {
			m_startLoanMoney = startLoanMoney;
    }

    /**
       @roseuid 3926DC3700FE
     */
    public float getLoanInterest() {
			return m_loanInterest;
    }

    /**
       @roseuid 3926DC4B0341
     */
    public void setLoanInterest(float loanInterest) {
    }

    public int getNumberOfDrugs() {
			return m_drugSettingList.size();
		}
}
