// Source file: c:/DopeWars/Framework/IConnector.java

package DopeWars.Framework;

/**
 * This is an interface to a connector.  All it needs to do is allow a way
 * to send information to the other side.
 *
 * @author Jordan Reed
 * @see Connector
 * @version 1.0
 * @since Phase 1.0 (Framework)
*/
public interface IConnector {

    /**
     * This is a way to send information to the other side.
     *
     * @param packetType The type of packet being send
     * @param thing An object to be sent with the packet
     * @roseuid 3925FD190077
     */
    public void send(int packetType, Object thing);
}
