package DopeWars;

import java.net.*;
import java.io.*;

// This is setup as a bridge between Sockets
public class Connector {
	InputStream m_inputStream;
	OutputStream m_outputStream;
	Socket m_socket;
	DopeServer m_dopeServer;
	DopeClient m_dopeClient;

	public Connector(Socket s, DopeServer dopeServer) {
		try {
			m_inputStream = s.getInputStream();
			m_outputStream = s.getOutputStream();
			m_socket = s;
			m_dopeServer = dopeServer;
			(new Thread(new SocketListener(m_inputStream, this))).start();
		} catch (IOException e) {
			System.out.println("a:" + e);
		}
	}

	public Connector(Socket s, DopeClient dopeClient) {
		try {
			m_inputStream = s.getInputStream();
			m_outputStream = s.getOutputStream();
			m_socket = s;
			m_dopeClient = dopeClient;
			(new Thread(new SocketListener(m_inputStream, this))).start();
		} catch (IOException e) {
			System.out.println("b:" + e);
		}
	}

	public void handlePacket(Packet tempPacket) {
		if ( !(m_dopeServer == null) ) {
			handleServerPacket(tempPacket);
		} else if ( !(m_dopeClient == null) ) {
			handleClientPacket(tempPacket);
		}
	}

	public void Send(int packetType, Object obj) {
		new Packet(m_outputStream, packetType, obj);
	}

	protected void handleServerPacket(Packet packet) {
		switch(packet.getType()) {

			case Packet.GENERIC:
				m_dopeServer.debug((String) packet.getThing());
				break;

			default:
				throw new IllegalArgumentException();
		}
	}

	protected void handleClientPacket(Packet packet) {
	}
}

class SocketListener implements Runnable {
	InputStream m_inputStream;
	Connector m_connector;

  public SocketListener (InputStream inputStream, Connector connector) {
		m_inputStream = inputStream;
		m_connector = connector;
	}

  public void run() {
		Packet tempPacket;
    while(true) {
			tempPacket = new Packet(m_inputStream);
			m_connector.handlePacket(tempPacket);
		}
	}
}