package DopeWars;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

public class DopeServer extends Frame implements WindowListener {
  private SettingPanel m_settingPanel;
  private StatusPanel m_statusPanel;
  private DebugPanel m_debugPanel;

  public DopeServer() {
		super("Dope Server");

		// Let's Build the Basic by adding three objects that are Paneles
		m_settingPanel = new SettingPanel();
		m_statusPanel = new StatusPanel();
		m_debugPanel = new DebugPanel();

		setLayout(new GridLayout(3,1));
		add(m_settingPanel);
		add(m_statusPanel);
		add(m_debugPanel);

		addWindowListener(this);

		(new Thread(new SocketThread(this), "Socket Thread")).start();
	}

  public static void main (String args[]) {
		Frame f = new DopeServer();
		f.setSize(640,480);
		f.setLocation(100,100);
		f.setVisible(true);
	}

  public void debug(String s) {
		m_debugPanel.addText(s);
	}

	public void windowClosing(WindowEvent we) {
		System.exit(0);
	}

	public void windowClosed(WindowEvent we) {}
	public void windowIconified(WindowEvent we) {}
	public void windowActivated(WindowEvent we) {}
	public void windowOpened(WindowEvent we) {}
	public void windowDeiconified(WindowEvent we) {}
	public void windowDeactivated(WindowEvent we) {}
}

class SettingPanel extends Panel {
	public SettingPanel() {
		add(new Label("Settings"));
	}

}

class StatusPanel extends Panel {
	public StatusPanel() {
		add(new Label("Status"));
	}

}

class DebugPanel extends Panel {
	private TextArea m_debugText;

	public DebugPanel() {
		m_debugText = new TextArea("", 8, 80); //, SCROLLBARS_BOTH);
		m_debugText.setEditable(false);
		m_debugText.setText("Debug...\n");
		add(m_debugText);
	}

	public void addText(String newText) {
		m_debugText.setText(m_debugText.getText() + newText + "\n");
	}
}

class SocketThread implements Runnable {
	private DopeServer m_DopeServer;

	public SocketThread(DopeServer dopeServer) {
		m_DopeServer = dopeServer;
	}

	public void run() {
		Connector tempConnector;
		try {
    	ServerSocket s1 = new ServerSocket(4440);
    	Socket s;
    	Packet packet;
			while(true) {
				debug("Waiting for connection");
				s = s1.accept();
				debug("Connection established");
				tempConnector = new Connector(s, m_DopeServer);
			}
		} catch (IOException e) {
		}
	}

  private void debug(String s) {
		m_DopeServer.debug(s);
	}
}