package DopeWars;

import java.net.*;
import java.io.*;

public class Packet {
	public static final String START = "Start";
	public static final String STOP = "Stop";
	public static final int GENERIC = 1;

	private int m_packetType;
	private Object m_thing;

  public Packet(InputStream in) {
		String tempString;
		Integer tempInteger;

    try {
			int c;
			ObjectInputStream ois = new ObjectInputStream(in);

			// Read in the Header
			tempString = (String) ois.readObject();
			if( ! tempString.equals(START) ) {
				throw new IllegalArgumentException();
			}

			// Read in the Type
			tempInteger = (Integer) ois.readObject();
			storePacketType(tempInteger.intValue());

			// Read in the Thing
			m_thing = (Object) ois.readObject();

			// Read in the Footer
			tempString = (String) ois.readObject();
			if( ! tempString.equals(STOP) ) {
				throw new IllegalArgumentException();
			}

			System.out.println(m_thing.toString());
		} catch (IOException e) {
			System.out.println("c:" + e);
		} catch (ClassNotFoundException e) {
			System.out.println("d:" + e);
		}
	}

	public Packet(OutputStream out, int packetType, Object thing) {
		System.out.println("New Write Packet Created");
		try {
			storePacketType(packetType);
			m_thing = thing;
			Send(out);
		} catch (IllegalArgumentException e) {
		}
	}

  private void storePacketType(int packetType) {
		switch (packetType) {
			case GENERIC:
			  m_packetType = GENERIC;
				break;
			default:
			  throw new IllegalArgumentException();
		}
	}

	private void Send(OutputStream out) {
		Integer packetType = new Integer(m_packetType);

		// Open Connection with Server
		try {
			System.out.println("Creating Streams");
			ObjectOutputStream oos = new ObjectOutputStream(out);

			// Send the Start Packet
			oos.writeObject(START);

			// Send the Packet Type
			oos.writeObject(packetType);

			// Send the Object
			oos.writeObject(m_thing);

			// End it
			oos.writeObject(STOP);

			System.out.println("Sent it all...");
		} catch (IOException e) {
			System.out.println("IOException:" + e);
		}
	}

	public void Add(Object thing) {
    m_thing = thing;
	}

	public Object getThing() {
		return m_thing;
	}

	public int getType() {
    return m_packetType;
	}
}